// $Id: engine.h,v 1.23 2003/01/16 16:11:27 toast Exp $

#ifndef _ENGINE_H_
#define _ENGINE_H_

#include <string>

#include "strtype"
#include "oomon.h"

extern bool DoingTrace;

void InitHash();
void FreeHash();
void Init_Link_Look_Table();
void Init_Nick_Change_Table();
void OnTraceUser(const std::string &, const std::string &, const std::string &,
  std::string, std::string);
void OnTraceUser(const std::string &, const std::string &, const std::string &,
  std::string);
void OnTraceClass();
void List_Users(StrList &, const std::string &);
void List_IPs(StrList &, const std::string &);
void OnClientConnect(std::string);
void OnClientExit(std::string);
void Bot_Reject(std::string);
void CS_Clones(std::string);
void CS_Nick_Flood(std::string);
void Check_Nick_Flood(std::string);
void Report_Domains(StrList &, const int);
void Link_Look_Notice(std::string);
void Trace_Notice(std::string);
void MOTD_Notice(std::string);
void Info_Notice(std::string);
void Report_Clones(StrList &);
void Report_Multi(StrList &, const int);
void Report_HMulti(StrList &, const int);
void Report_UMulti(StrList &, const int);
void Report_VMulti(StrList &, const int);
int  Kill_List_Users(const std::string &, const std::string &,
  const std::string &);
int  Kill_List_Users(const std::string &, const std::string &);
void Kill_Add_Report(std::string);
void Stats_Notice(std::string);
void List_Nicks(StrList &, const std::string &);
#ifdef AUTOPILOT
void SetAutoPilot(const std::string &, const bool);
bool GetAutoPilot();
#endif
#ifdef SERVICES
void Check_Services();
void On_Services_Notice(std::string);
void On_CA_Services_Notice(std::string);
#endif
void CountClasses(StrList &, const std::string & classname = "");
std::string Make_Kline(const std::string &, const int, const int);
void CheckProxy(const std::string &, const std::string &, const std::string &,
  const std::string &);

#define REASON_CLONES	"Clones are prohibited"
#define REASON_FLOODING	"Flooding is prohibited"
#define REASON_BOTS	"Bots are prohibited"
#define REASON_SPAM	"Spamming is prohibited"
#define REASON_LINKS	"Links lookers are prohibited"
#define REASON_TRACE	"repeated issuance of the /trace command"
#define REASON_MOTD	"MOTD flooding is prohibited"
#define REASON_INFO	"INFO flooding is prohibited"
#define REASON_WINGATE	"Open WinGate"
#define REASON_PROXY	"Open Proxy"
#define REASON_DNSBL	"Open Proxy (DNSBL)"

#define MK_CLONES	1
#define MK_FLOODING	2
#define MK_BOTS		3
#define MK_SPAM		4
#define MK_LINKS	5
#define MK_TRACE	6
#define MK_MOTD		7
#define MK_INFO		8
#define MK_WINGATE	9
#define MK_PROXY	10

#endif
